
#IFNDEF MSHELPSERVICES_H
#DEFINE MSHELPSERVICES_H

#define GUID_TLBID_MSHelpServices <0x31411197,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

/*
library MSHelpServices
{
    // TLib :     // TLib : OLE Automation : {00020430-0000-0000-C000-000000000046}
    importlib("STDOLE2.TLB");

    // Forward declare all types defined in this typelib
    interface IHxHierarchy;
    interface IHxTopic;
    interface IHxAttributeList;
    interface IHxAttribute;
    interface IEnumHxAttribute;
    interface IHxRegister;
    interface IHxIndex;
    interface IHxSession;
    interface IHxTopicList;
    interface IEnumHxTopic;
    interface IHxQuery;
    interface IHxCollection;
    interface IHxAttrNameList;
    interface IHxAttrName;
    interface IHxAttrValueList;
    interface IHxAttrValue;
    interface IEnumHxAttrValue;
    interface IEnumHxAttrName;
    interface IHxFilters;
    interface IHxRegFilterList;
    interface IHxRegFilter;
    interface IEnumHxRegFilter;
    interface IHxSampleCollection;
    interface IHxSample;
    interface IHxRegistryWalker;
    interface IHxRegNamespaceList;
    interface IHxRegNamespace;
    interface IEnumHxRegNamespace;
    interface IHxRegTitle;
    interface IHxRegTitleList;
    interface IEnumHxRegTitle;
    interface IHxRegPlugIn;
    interface IHxRegPlugInList;
    interface IEnumHxRegPlugIn;
    interface IHxRegisterSession;
    interface IHxPlugIn;
    interface IHxInitialize;
    interface IHxCancel;
    dispinterface IHxSessionEvents;
    dispinterface IHxRegisterSessionEvents;
    interface IHxRegisterProtocol;
*/
#IFNDEF Unknown
	Unknown STRUCT
	   QueryInterface		DD
	   AddRef				DD
	   Release				DD
	ENDS
#ENDIF

#IFNDEF Dispatch
	Dispatch STRUCT
		GetTypeInfoCount DD
		GetTypeInfo DD
		GetIDsOfNames DD
		Invoke DD
	ENDS
#ENDIF

#define GUID_IID_IHxHierarchy <0x314111B2,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxHierarchy STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetRoot DD
	GetParent DD
	GetSibling DD
	GetFirstChild DD
	GetNextFromUrl DD
	GetPrevFromUrl DD
	GetType DD
	IsNew DD
	HasChild DD
	GetSyncInfo DD
	GetTitle DD
	GetImageIndexes DD
	GetURL DD
	OnNavigation DD
	OnHierarchyNavigation DD
	GetProperty DD
	GetNextFromNode DD
	GetPrevFromNode DD
	GetTopic DD
	GetOpenImageIndex DD
	GetClosedImageIndex DD
	PrintNode DD
ENDS

HxHierarchy_Book = 3
HxHierarchy_BookPage = 4
HxHierarchy_Page = 5
HxHierarchy_Unknown = 8

HxHierarchyTocFont = 0
HxHierarchyTocFontSize = 1
HxHierarchyTocLangId = 2
HxHierarchyTocCharSet = 3
HxHierarchyTocId = 4
HxHierarchyTocFileVer = 5
HxHierarchyTocIconFile = 6
HxHierarchyTocParentNodeIcon = 7
HxHierarchyTocIcon = 8

#define GUID_IID_IHxTopic <0x31411196,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxTopic STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Title DD
	URL DD
	Location DD
	Rank DD
	Attributes DD
	GetInfo DD
	GetProperty DD
	SetProperty DD
	HasAttribute DD
	HasAttrName DD
	HighlightDocument DD
ENDS

HxTopicGetTOCTitle = 0
HxTopicGetRLTitle = 1
HxTopicGetHTMTitle = 2

HxTopicGetTitleFullURL = 0
HxTopicGetTitleFileName = 1
HxTopicGetTitleNoDefault = 2

#define GUID_IID_IHxAttributeList <0x314111AB,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxAttributeList STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Count DD
	ItemAt DD
	EnumAttribute DD
	_NewEnum DD
	Item DD
ENDS

#define GUID_IID_IHxAttribute <0x314111A9,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxAttribute STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetProperty DD
	SetProperty DD
	Name DD
	Value DD
	DisplayName DD
	DisplayValue DD
ENDS

HxPropIdQueryFirst = 0

#define GUID_IID_IEnumHxAttribute <0x314111AD,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IEnumHxAttribute STRUCT
	IUnknown Unknown <>
	Next DD
	Reset DD
	Skip DD
	Clone DD
ENDS

HxTopicPropIdFirst = 0

HxHierarchy_PrintNode_Option_Node = 0
HxHierarchy_PrintNode_Option_Children = 1

#define GUID_IID_IHxRegister <0x314111BC,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegister STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	RegisterNamespace DD
	IsNamespace DD
	GetCollection DD
	GetDescription DD
	RemoveNamespace DD
	RegisterHelpFile DD
	RegisterMedia DD
	RemoveHelpFile DD
	RegisterHelpFileSet DD
ENDS

#define GUID_IID_IHxIndex <0x314111CC,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxIndex STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetSession DD
	Count DD
	GetStringFromSlot DD
	GetLevelFromSlot DD
	GetSlotFromString DD
	GetTopicsFromSlot DD
	GetTopicsFromString DD
	GetInfoFromSlot DD
	GetProperty DD
	GetCrossRef DD
	GetFullStringFromSlot DD
	GetCrossRefSlot DD
ENDS

#define GUID_IID_IHxSession <0x31411192,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxSession STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Initialize DD
	Query DD
	QueryForTopic DD
	QueryForUrl DD
	GetNavigationInterface DD
	GetNavigationObject DD
	GetQueryObject DD
	Collection DD
	LangId DD
	LangId DD
	GetFilterList DD
ENDS

#define GUID_IID_IHxTopicList <0x31411194,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxTopicList STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Item DD
	ItemAt DD
	EnumTopics DD
	_NewEnum DD
	Count DD
ENDS

#define GUID_IID_IEnumHxTopic <0x31411195,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IEnumHxTopic STRUCT
	IUnknown Unknown <>
	Next DD
	Reset DD
	Skip DD
	Clone DD
ENDS

#define GUID_IID_IHxQuery <0x31411193,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxQuery STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Query DD
	QueryForTopic DD
	QueryForUrl DD
ENDS

HxQuery_No_Option = 0
HxQuery_FullTextSearch_Title_Only = 1
HxQuery_FullTextSearch_Enable_Stemming = 2
HxQuery_FullTextSearch_SearchPrevious = 4
HxQuery_KeywordSearch_CaseSensitive = 10
HxQuery_KeywordSearch_AllowDuplicates = 16
HxQuery_FullTextSearch_Wildcard_Preserve = 128
HxQuery_FullTextSearch_ReturnRanking = 256
HxQuery_FullTextSearch_MinImprovements = 512

#define GUID_IID_IHxCollection <0x314111A1,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxCollection STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetProperty DD
	SetProperty DD
	URL DD
	AttributeNames DD
	Filters DD
	Title DD
	MergeIndex DD
	GetFilterTopicCount DD
ENDS

HxCollectionProp_NamespaceName = 1
HxCollectionProp_Font = 2
HxCollectionProp_FontSize = 3
HxCollectionProp_LangId = 4
HxCollectionProp_CharSet = 5
HxCollectionProp_Id = 6
HxCollectionProp_FileVer = 7
HxCollectionProp_CopyRight = 8

#define GUID_IID_IHxAttrNameList <0x314111CE,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxAttrNameList STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	ItemAt DD
	EnumAttrName DD
	NewEnum DD
	Item DD
ENDS

#define GUID_IID_IHxAttrName <0x314111D2,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxAttrName STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetProperty DD
	SetProperty DD
	Name DD
	DisplayName DD
	Flag DD
	AttributeValues DD
ENDS

#define GUID_IID_IHxAttrValueList <0x314111D4,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxAttrValueList STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Count DD
	ItemAt DD
	EnumAttrValue DD
	_NewEnum DD
	Item DD
ENDS

#define GUID_IID_IHxAttrValue <0x314111D8,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxAttrValue STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetProperty DD
	SetProperty DD
	Value DD
	DisplayValue DD
	Flag DD
ENDS

#define GUID_IID_IEnumHxAttrValue <0x314111D6,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IEnumHxAttrValue STRUCT
	IUnknown Unknown <>
	Next DD
	Reset DD
	Skip DD
	Clone DD
ENDS

#define GUID_IID_IEnumHxAttrName <0x314111D0,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IEnumHxAttrName STRUCT
	IUnknown Unknown <>
	Next DD
	Reset DD
	Skip DD
	Clone DD
ENDS

#define GUID_IID_IHxFilters <0x314111E3,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxFilters STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Count DD
	GetFilter DD
	GetFilterName DD
	GetFilterQuery DD
	RegisterFilter DD
	RemoveFilter DD
	FindFilter DD
	SetNamespace DD
	SetCollectionFiltersFlag DD
ENDS

#define GUID_IID_IHxRegFilterList <0x31411212,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegFilterList STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Item DD
	ItemAt DD
	EnumRegFilter DD
	_NewEnum DD
	Count DD
	FindFilter DD
ENDS

#define GUID_IID_IHxRegFilter <0x31411221,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegFilter STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetProperty DD
ENDS

HxRegFilterName = 0
HxRegFilterQuery = 1


#define GUID_IID_IEnumHxRegFilter <0x3141121C,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IEnumHxRegFilter STRUCT
	IUnknown Unknown <>
	Next DD
	Reset DD
	Skip DD
	Clone DD
ENDS

HxIndexFont = 0
HxIndexFontSize = 1
HxIndexLangId = 2
HxIndexCharSet = 3
HxIndexTitleStr = 4
HxIndexIsVisible = 5
HxIndexId = 6

#define GUID_IID_IHxSampleCollection <0x314111E6,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxSampleCollection STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetSampleFromId(
ENDS

#define GUID_IID_IHxSample <0x314111E8,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxSample STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	SampleId DD
	LoadString DD
	DestinationDir DD
	ProjectFileExt DD
	FileCount DD
	GetFileNameAtIndex DD
	CopyFileAtIndex DD
	ChooseDirectory DD
	GetFileTextAtIndex DD
ENDS

HxSampleFileCopyNoOption = 0
HxSampleFileCopyOverwrite = 1
HxSampleFileCopyFileOnly = 2

#define GUID_IID_IHxRegistryWalker <0x314111EF,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegistryWalker STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	RegisteredNamespaceList DD
ENDS

#define GUID_IID_IHxRegNamespaceList <0x314111F3,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegNamespaceList STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Item DD
	ItemAt DD
	EnumRegNamespace DD
	_NewEnum DD
	Count DD
ENDS

#define GUID_IID_IHxRegNamespace <0x314111F1,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegNamespace STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Name DD
	GetProperty DD
	IsTitle DD
ENDS

HxRegNamespaceTitleList = 0
HxRegNamespacePlugInList = 1
HxRegNamespaceName = 2
HxRegNamespaceCollection = 3
HxRegNamespaceDescription = 4
HxRegNamespaceFilterList = 8

#define GUID_IID_IEnumHxRegNamespace <0x314111F5,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IEnumHxRegNamespace STRUCT
	IUnknown Unknown <>
	Next DD
	Reset DD
	Skip DD
	Clone DD
ENDS

#define GUID_IID_IHxRegTitle <0x31411202,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegTitle STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetProperty DD
ENDS

HxRegTitleFileName = 0
HxRegTitleIndexName = 1
HxRegTitleQueryName = 2
HxRegTitleId = 3
HxRegTitleLangId = 4
HxRegAttrQueryName = 5
HxRegTitleHxsMediaLoc = 6
HxRegTitleHxqMediaLoc = 7
HxRegTitleHxrMediaLoc = 8
HxRegTitleSampleMediaLoc = 9

#define GUID_IID_IHxRegTitleList <0x31411203,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegTitleList STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Item DD
	ItemAt DD
	EnumRegTitle DD
	_NewEnum DD
	Count DD
ENDS

#define GUID_IID_IEnumHxRegTitle <0x31411204,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IEnumHxRegTitle STRUCT
	IUnknown Unknown <>
	Next DD
	Reset DD
	Skip DD
	Clone DD
ENDS

#define GUID_IID_IHxRegPlugIn <0x3141120A,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegPlugIn STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	GetProperty DD
ENDS

HxRegPlugInName = 0

#define GUID_IID_IHxRegPlugInList <0x3141120B,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegPlugInList STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Item DD
	ItemAt DD
	EnumRegPlugIn DD
	_NewEnum DD
	Count DD
ENDS

#define GUID_IID_IEnumHxRegPlugIn <0x3141120C,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IEnumHxRegPlugIn STRUCT
	IUnknown Unknown <>
	Next DD
	Reset DD
	Skip DD
	Clone DD
ENDS

#define GUID_IID_IHxRegisterSession <0x31411218,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegisterSession STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	CreateTransaction DD
	PostponeTransaction DD
	ContinueTransaction DD
	CommitTransaction DD
	RevertTransaction DD
	GetRegistrationObject DD
ENDS

HxRegisterSession_IHxRegister = 0
HxRegisterSession_IHxFilters = 1
HxRegisterSession_IHxPlugIn = 2

#define GUID_IID_IHxPlugIn <0x314111DA,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxPlugIn STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	RegisterHelpPlugIn DD
	RemoveHelpPlugIn DD
ENDS

#define GUID_IID_IHxInitialize <0x314111AE,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxInitialize STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Initialize DD
	get_filter DD
	put_filter DD
ENDS

#define GUID_IID_IHxCancel <0x31411225,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxCancel STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	get_Cancel DD
	put_Cancel DD
ENDS

HxCancelStatus_Continue = 0
HxCancelStatus_Cancel = 1

#define GUID_IID_IHxSessionEvents <0x314111ED,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxSessionEvents STRUCT
	QueryCancel DD
	IndexMergeStatus DD
	PrintMergeStatus DD
	MergeIndexFileName DD
ENDS

#define GUID_IID_IHxRegisterSessionEvents <0x31411223,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegisterSessionEvents STRUCT
	FiltersChanged DD
ENDS

#define GUID_CLSID_IHxSession <0x31411198,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>
#define GUID_CLSID_IHxRegistryWalker <0x314111F0,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>
#define GUID_CLSID_IHxRegisterSession <0x31411219,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>
#define GUID_CLSID_IHxRegisterProtocol <0x31411228,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

#define GUID_IID_IHxRegisterProtocol <0x31411227,0xA502,0x11D2,0xBB,0xCA,0x00,0xC0,0x4F,0x8E,0xC2,0x94>

IHxRegisterProtocol STRUCT
	IUnknown Unknown <>
	IDispatch Dispatch <>
	Register DD
	Unregister DD
ENDS

HxSearchMetaBegin = "[SrchMeta["
HxSearchMetaEnd = "]SrchMeta]"
HxSearchTocBegin = "[Toc["
HxSearchTocEnd = "]Toc]"
HxSearchInclBegin = "[Incl["
HxSearchInclEnd = "]Incl]"
HxSearchExclBegin = "[Excl["
HxSearchExclEnd = "]Excl]"

#define HXSESSION_VI_PROGID "HxDS.HxSession"
#define HXREGISTRYWALKER_VI_PROGID "HxDs.HxRegistryWalker"
#define HXREGISTERSESSION_VI_PROGID "HxDS.HxRegisterSession"
#define HXREGISTERPROTOCOL_VI_PROGID "HxDS.HxRegisterProtocol"

// Monikers
;<ItemMoniker Name="!DefaultToc" ProgId="HxDs.HxHierarchy" InitData=""/>
;<ItemMoniker Name="!DefaultFullTextSearch" ProgId="HxDs.HxFullTextSearch" InitData=""/>
;<ItemMoniker Name="!DefaultAssociativeIndex" ProgId="HxDs.HxIndex" InitData="A"/>
;<ItemMoniker Name="!DefaultKeywordIndex" ProgId="HxDs.HxIndex" InitData="K"/>
;<ItemMoniker Name="!DefaultContextWindowIndex" ProgId="HxDs.HxIndex" InitData="F"/>
;<ItemMoniker Name="!SampleInfo" ProgId="HxDs.HxSampleCollection" InitData=""/>

#ENDIF